function [upperbound, lowerbound, C,B] = GenConstraint(logc,label,params)
% data constriant setting for metric learing
%% calculate Log-Euclidean distance of the original SPD data
tr_log = zeros(size(logc,3),size(logc,3));
B = cell(size(logc,3),size(logc,3));
for i = 1 : size(logc,3)
    T1=logc(:,:,i);
    for j = i+1 : size(logc,3)
        T2=logc(:,:,j);
        T = T1-T2;
        B{i,j} = T'*T;
        B{j,i} = B{i,j};
        tr_log(i,j) = trace(B{i,j});
        tr_log(j,i) = tr_log(i,j);
    end
end
%% calculate the lowerbound and the upperbound of the original Log-Euclidean distances

LEuDist = tril(tr_log);
LEuDist = LEuDist(:);
LEuDist(find(LEuDist==0)) = [];

meanDist = mean(LEuDist(:));
stdDist = std(LEuDist(:));
lowerbound = fix(meanDist - params.zeta*stdDist);
upperbound = fix(meanDist + params.zeta*stdDist);
%% calculate the data constraint C 
[index_pair] = GenConstraintPairs(label',params.prop);
npair = size(index_pair,1);
C = zeros(npair,4);
for i = 1 : npair
    C(i,1:2) = index_pair(i,:);
    if(mod(i,params.prop)==1)
        C(i,3) = 1;
        C(i,4) = lowerbound;
    else
        C(i,3) = -1;
        C(i,4) = upperbound;
    end    
end
